<template>
  <div class="row pl-3 pt-2">
    <div class="col-md-3 lg-3">
      <div class="card">
        <div class="card-header">
          <label>
            <i class="fas fa-search"></i> Cari Pengguna:
          </label>
          <input v-model="search" type="text" placeholder="Cari Nama">
        </div>

        <div class="card-body">
          <ul class="list-group">
            <li
              @click="openChatBox(friend)"
              v-for="friend in filteredItems"
              :key="friend.id"
              class="list-group-item"
            >
              <span>{{friend.name}}</span>
              <span
                v-if="friend.session && (friend.session.unreadCount > 0)"
                class="ml-2 badge badge-danger"
              >{{friend.session.unreadCount}}</span>
              <i class="fa fa-circle float-right text-success" v-if="friend.online"></i>
            </li>
          </ul>
        </div>
      </div>
    </div>

    <div class="col-md-9 lg-9">
      <div v-if="boxOpen == false" class="alert alert-info">Klik Nama Pengguna Disamping Kiri Untuk Memulai percakapan.</div>
      <div v-for="friend in friends" :key="friend.id">
        <div v-if="friend.session">
          <message-component
            v-once
            :friend="friend"
            v-if="friend.session.open"
            v-on:close="closeChatBox(friend)"
          />
        </div>
        
      </div>
    </div>
  </div>
</template>

<script>
import MessageComponent from "./MessageComponent.vue";

export default {
  data() {
    return {
      friends: [],
      search: "",
      boxOpen: false
    };
  },
  computed: {
    filteredItems() {
      return this.friends.filter(friend => {
        console.log(friend);
        return (
          friend.name.toLowerCase().indexOf(this.search.toLowerCase()) > -1
        );
      });
    }
  },
  name: "chat-component",
  created() {
    this.getFriends();

    Echo.channel("Chat").listen("SessionEvent", e => {
      let friend = this.friends.find(friend => friend.id == e.session_by);
      friend.session = e.session;
      this.listenForEverySession(friend);
    });

    Echo.join("Chat")
      .here(users => {
        this.friends.forEach(friend => {
          users.forEach(user => {
            if (user.id == friend.id) {
              friend.online = true;
            }
          });
        });
      })
      .joining(user => {
        this.friends.map(friend => {
          if (friend.id == user.id) {
            return (friend.online = true);
          }
        });
      })
      .leaving(user => {
        this.friends.map(friend => {
          if (friend.id == user.id) {
            return (friend.online = false);
          }
        });
      });
  },
  mounted() {
    console.log("Component mounted.");
  },
  methods: {
    closeChatBox(friend) {
      friend.session.open = false;
      this.boxOpen = false;
    },
    listenForEverySession(friend) {
      Echo.private(`Chat.${friend.session.id}`).listen("PrivateChatEvent", e =>
        friend.session.open ? "" : friend.session.unreadCount++
      );
    },
    getFriends() {
      axios.get(`/session/get-friends`).then(res => {
        console.log("Get Friend List: " + res.data.data);
        this.friends = res.data.data;
        this.friends.forEach(friend => {
          if (friend.session) {
            this.listenForEverySession(friend);
          }
        });
      });
    },
    openChatBox(friend) {
      if (friend.session != null) {
        //open chat box
        this.friends.forEach(item =>
          item.session ? (item.session.open = false) : ""
        );
        friend.session.open = true;
        friend.session.unreadCount = 0;
      } else {
        // Create Session once
        this.createSession(friend);
      }
      this.boxOpen = true;
    },
    createSession(friend) {
      axios
        .post("/session/create", { friend_id: friend.id })
        .then(res => {
          friend.session = res.data.data;
          friend.session.open = true;
        })
        .catch(err => console.log(err));
    }
  },
  components: {
    MessageComponent
  }
};
</script>

<style scoped>
li.list-group-item:hover {
  cursor: pointer;
}

li.list-group-item {
  border-left: 4px solid #202e78;
}
</style>

